package com.winhc.bigdata.bean;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;

import java.util.Arrays;
import java.util.List;

/**
 * 输出实体类
 */
public class BaseCaseInfo {
    private String flag;
    private String detail_id;
    private JSONArray yg_name;
    private JSONArray bg_name;
    private String case_no;
    private String case_reason;
    private JSONArray party_title;


    public BaseCaseInfo() {

    }

    public BaseCaseInfo(String flag, String detail_id, JSONArray yg_name, JSONArray bg_name, String case_no, String case_reason, JSONArray party_title) {
        this.flag = flag;
        this.detail_id = detail_id;
        this.yg_name = yg_name;
        this.bg_name = bg_name;
        this.case_no = case_no;
        this.case_reason = case_reason;
        this.party_title = party_title;
    }

    public String getFlag() {
        return flag;
    }

    public void setFlag(String flag) {
        this.flag = flag;
    }

    public String getDetail_id() {
        return detail_id;
    }

    public void setDetail_id(String detail_id) {
        this.detail_id = detail_id;
    }

    public JSONArray getYg_name() {
        return yg_name;
    }

    public void setYg_name(JSONArray yg_name) {
        this.yg_name = yg_name;
    }

    public JSONArray getBg_name() {
        return bg_name;
    }

    public void setBg_name(JSONArray bg_name) {
        this.bg_name = bg_name;
    }

    public String getCase_no() {
        return case_no;
    }

    public void setCase_no(String case_no) {
        this.case_no = case_no;
    }

    public String getCase_reason() {
        return case_reason;
    }

    public void setCase_reason(String case_reason) {
        this.case_reason = case_reason;
    }

    public JSONArray getParty_title() {
        return party_title;
    }

    public void setParty_title(JSONArray party_title) {
        this.party_title = party_title;
    }

    @Override
    public String toString() {
        return "CaseInfo{" +
                "flag='" + flag + '\'' +
                ", detail_id='" + detail_id + '\'' +
                ", yg_name='" + yg_name + '\'' +
                ", bg_name='" + bg_name + '\'' +
                ", case_no='" + case_no + '\'' +
                ", case_reason='" + case_reason + '\'' +
                ", party_title='" + party_title + '\'' +
                '}';
    }


    public static final List<String> keywords = Arrays.asList("某", "*", "＊", "ｘ", "ⅹ", "x", "X", "×");

    public Integer getWeightV2() {
        int w = 0;
        if (yg_name != null && !yg_name.isEmpty()) {
            w = w + 1;
        }
        if (bg_name != null && !bg_name.isEmpty()) {
            w = w + 1;
        }
        w = w + nameWeigth(yg_name, bg_name);
        return w;
    }

    public Integer nameWeigth(JSONArray yg_name, JSONArray bg_name) {
        boolean b = StrUtil.containsAny(JSON.toJSONString(yg_name) + JSON.toJSONString(bg_name), keywords.toArray(new CharSequence[0]));
        return b ? 0 : 1;

    }

}