package com.winhc.bigdata.udf;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.aliyun.odps.*;
import com.aliyun.odps.account.Account;
import com.aliyun.odps.account.AliyunAccount;
import com.aliyun.odps.udf.ExecutionContext;
import com.aliyun.odps.udf.UDF;
import com.winhc.bigdata.bean.ColumnData;
import com.winhc.bigdata.utils.BaseUtils;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @Author: π
 * @Description: 去除标签
 */
public class DataToStr extends UDF {

    private static final String endPoint = BaseUtils.isWindows() ? "http://service.odps.aliyun.com/api" : "http://odps-ext.aliyun-inc.com/api";
    private static final String accessKeyId = "LTAI4FynxS5nNuKyZ3LHhMX5";
    private static final String accessSecret = "r6gWoySXC8kSK4qnfKRxEuWJ5uHIiE";

    public static Odps getOdpsInstance() {
        Account account = new AliyunAccount(accessKeyId, accessSecret);
        Odps odps = new Odps(account);
        odps.setEndpoint(endPoint);
        odps.setDefaultProject("winhc_ng");
        return odps;
    }

    static List<String> tns = Arrays.asList("company", "company_holder", "company_staff", "private_enterprise", "company_liquidating_info",
            "company_change", "company_annual_report", "company_annual_report_out_investment", "company_annual_report_out_guarantee",
            "company_annual_report_change", "company_annual_report_equity_change", "company_annual_report_holder", "company_annual_report_webinfo",
            "company_annual_report_social_security", "company_dishonest_info", "company_zxr", "company_zxr_restrict", "company_zxr_final_case",
            "company_send_announcement", "wenshu_detail_v2", "company_court_open_announcement", "company_court_register", "company_court_announcement",
            "company_judicial_assistance", "auction_tracking", "zxr_evaluate_results", "zxr_evaluate", "restrictions_on_exit", "litigation_mediation",
            "bankruptcy_open_case", "bankruptcy_open_announcement", "bankruptcy_judgment_document", "company_punishment_info_creditchina", "company_abnormal_info",
            "company_equity_info", "company_mortgage_info", "company_mortgage_pawn", "company_mortgage_change", "company_mortgage_people",
            "company_env_punishment", "company_tax_contravention", "company_own_tax", "company_illegal_info", "company_brief_cancel_announcement",
            "company_brief_cancel_announcement_objection", "company_brief_cancel_announcement_result", "company_equity_pledge", "company_ipr_pledge",
            "cancellation_announcement", "company_bid_all", "company_employment", "company_certificate", "company_customs_credit",
            "company_customs_credit_administrative_penalty", "company_customs_credit_rating", "company_license_creditchina_new", "company_land_publicity",
            "company_land_announcement", "company_land_transfer", "company_land_mortgage", "company_tax", "company_finance", "company_check_info",
            "property_rights_transaction", "company_double_random_check_info", "company_double_random_check_result_info", "company_tm", "company_tm_notice",
            "company_tm_step", "company_tm_goods", "company_patent_new", "company_copyright_reg", "company_copyright_works", "company_icp",
            "construction_qualification", "construction_person", "construction_project", "company_holder_sponsor");


    public static final Map<String, List<String>> tn_cols_filters = new HashMap<String, List<String>>() {{
        put("company_send_announcement", Arrays.asList("litigant", "plaintiff", "defendant", "source_url", "source"));
        put("company_court_open_announcement", Arrays.asList("litigant", "plaintiff", "defendant", "source"));
        put("company_court_register", Arrays.asList("litigant", "plaintiff", "defendant", "third", "source_url", "source"));
        put("company_court_announcement", Arrays.asList("source", "litigant", "plaintiff"));
        put("litigation_mediation", Arrays.asList("litigant", "plaintiff", "defendant", "source_url", "source"));
        put("company_patent", Collections.singletonList("applicant_name"));
        put("company_holder", Arrays.asList("invtype_cn", "blictype_cn", "country_cn", "blicno"));
    }};

    public static final Map<String, List<String>> tn_cols_out = new HashMap<String, List<String>>() {{
        put("company", Arrays.asList("company_id", "name", "history_names", "reg_number", "credit_code", "create_time",
                "update_time", "deleted", "org_number"));
    }};

    private static Object getValue(JSONObject data, String name, String typeName) {
        Object d;
        switch (typeName) {
            case "BIGINT":
                d = data.getBigInteger(name);
                break;
            case "DOUBLE":
                d = data.getDouble(name);
                break;
            case "BOOLEAN":
                d = data.getBoolean(name);
                break;
            case "DATETIME":
            case "DATE":
            case "TIMESTAMP":
                try {
                    d = data.getString(name);
                } catch (Exception e) {
                    d = null;
                }
                break;
            case "STRING":
                d = data.getString(name);
                break;
            case "DECIMAL":
                d = data.getBigDecimal(name);
                break;
            case "INT":
            case "TINYINT":
            case "SMALLINT":
                d = data.getInteger(name);
                break;
            case "FLOAT":
                d = data.getFloat(name);
                break;
            default:
                d = data.getString(name);
                break;
        }
        return d;
    }

    //    static Map<String, List<Column>> column_list = new HashMap<>();
    static Map<String, List<JSONObject>> column_list_v2 = new HashMap<>();

//    static {
//        Odps odps = getOdpsInstance();
//        // 获取表
//        tns.forEach(tn -> DataToStr.init(odps, tn));
//    }


    @Override
    public void setup(ExecutionContext ctx) {

        String s = BaseUtils.readeResourceFile("table_schema.json");
        JSONObject jj = JSON.parseObject(s);
        jj.forEach((k, v) -> {
            column_list_v2.put(k, (List<JSONObject>) v);
        });
//        column_list_v2 = columnData.getData();
//        Odps odps = getOdpsInstance();
//        // 获取表
//        tns.forEach(tn -> DataToStr.init(odps, tn));
//        System.out.println(JSON.toJSONString(column_list_v2));
    }

    public void to_json() {
        Odps odps = getOdpsInstance();
        // 获取表
        tns.forEach(tn -> DataToStr.init(odps, tn));
        System.out.println(JSON.toJSONString(column_list_v2));
    }


    public static void init(Odps odps, String tn) {
        String tableName = "ads_" + tn + "_v9";
        TableSchema table;
        try {
            table = odps.tables().get(tableName).getSchema();
        } catch (Exception e) {
            return;
        }
        // 获取表
        List<Column> columns = table
                .getColumns()
                .stream()
                .filter(c -> {
/*                    if (tn_cols_out.containsKey(tn)) {
                        return tn_cols_out.get(tn).contains(c.getName());
                    }*/
                    return !tn_cols_filters.getOrDefault(tn, new ArrayList<>()).contains(c.getName()) && !"ds".equalsIgnoreCase(c.getName());
                })
                .collect(Collectors.toList());
//        column_list.put(tn, columns);

        List<JSONObject> re = columns.stream().map(c -> {
            JSONObject json = new JSONObject();
            json.put("name", c.getName());
            json.put("type", c.getTypeInfo().getTypeName());
            return json;
        }).collect(Collectors.toList());
        column_list_v2.put(tn, re);
    }


    public String evaluate(String text, String tn) {
        if (null == text) return null;
        JSONObject data = JSON.parseObject(text);

        if (!tns.contains(tn)) {
            return null;
        }
        JSONObject out = new JSONObject();
        column_list_v2.get(tn).forEach(c -> {
            String name = c.getString("name");
            String typeName = c.getString("type");
            Object value = getValue(data, name, typeName);
            out.put(name, value);
        });
        return JSON.toJSONString(out, SerializerFeature.WriteMapNullValue);
    }

    public static void main(String[] args) {
        DataToStr res = new DataToStr();
        res.to_json();
        res.setup(null);
        String text = "{\"amount\":\"30.0\",\"blicno\":\"\",\"blictype_cn\":\"\",\"capital\":\"[{\\\"amomon\\\":\\\"30万元\\\",\\\"paymet\\\":\\\"货币\\\",\\\"time\\\":\\\"2053-12-31\\\"}]\",\"capital_actual\":\"\",\"company_id\":\"f12c64a6dfe0401124ff2884b84a33d5\",\"company_name\":\"扬州卓联建筑安装劳务有限公司\",\"country_cn\":\"中国\",\"create_time\":\"2023-12-24 18:28:18\",\"deleted\":\"0\",\"holder_id\":\"pa2673337db25ed7136408ece9f4b33bc\",\"holder_name\":\"李燕\",\"holder_type\":\"1\",\"invtype_cn\":\"自然人股东\",\"major_shareholders\":\"1\",\"percent\":\"1.0\",\"rowkey\":\"f12c64a6dfe0401124ff2884b84a33d5_4039fe1b6fec461da63a1cd4632be0e3\",\"update_time\":\"2023-12-25 02:29:39\"}";
        String text1 = "{\"actual_capital_amount\":\"\",\"actual_capital_currency\":\"\",\"approved_time\":\"2021-12-17 00:00:00\",\"base\":\"\",\"business_scope\":\"法律、法规、国务院决定规定禁止的不得经营；法律、法规、国务院决定规定应当许可（审批）的，经审批机关批准后凭许可（审批）文件经营;法律、法规、国务院决定规定无需许可（审批）的，市场主体自主选择经营。（一般项目：白酒制造及销售（除许可业务外，可自主依法经营法律法规非禁止或限制的项目））\",\"cancel_date\":\"\",\"cancel_reason\":\"\",\"cate_first_code\":\"21\",\"cate_second_code\":\"100\",\"cate_third_code\":\"128\",\"city_code\":\"05\",\"company_id\":\"383e5babed67c0fb9b27fc5ad3b8eb4e\",\"company_org_type\":\"个体工商户\",\"company_org_type_new_std\":\"[个体工商户]\",\"company_type\":\"1\",\"county_code\":\"02\",\"crawled_time\":\"2023-12-24 21:45:39\",\"create_time\":\"2023-12-24 21:45:39\",\"credit_code\":\"92520596MA7EBE7210\",\"deleted\":\"0\",\"dims_approved_time\":\"{}\",\"emails\":\"\",\"estiblish_time\":\"2021-12-17 00:00:00\",\"from_time\":\"\",\"history_names\":\"\",\"lat\":\"27.172146\",\"legal_entities\":\"[{\\\"deleted\\\":0,\\\"name\\\":\\\"蒲春荣\\\",\\\"appointment_date\\\":\\\"\\\",\\\"id\\\":\\\"pc2256049434541ffa62a45409fffb5f9\\\",\\\"type\\\":1,\\\"resignation_date\\\":\\\"\\\"}]\",\"lng\":\"105.375662\",\"logo\":\"\",\"name\":\"毕节金海湖新区蒲春荣酒厂\",\"name_alias\":\"蒲春荣\",\"name_en\":\"\",\"new_cid\":\"\",\"org_approved_institute\":\"\",\"org_number\":\"MA7EBE721\",\"parent_company_id\":\"\",\"phones\":\"13984719716\",\"province_code\":\"52\",\"reg_capital\":\"\",\"reg_capital_amount\":\"\",\"reg_capital_currency\":\"\",\"reg_institute\":\"毕节市市场监督管理局高新区分局\",\"reg_location\":\"贵州省毕节市金海湖新区岔河镇岔河村八组\",\"reg_number\":\"520596600167912\",\"reg_status\":\"存续（在营、开业、在册）\",\"reg_status_std\":\"存续\",\"revoke_date\":\"\",\"revoke_reason\":\"\",\"rowkey\":\"383e5babed67c0fb9b27fc5ad3b8eb4e\",\"score\":\"\",\"social_security_staff_num\":\"\",\"tel_info\":\"[{\\\"deleted\\\":\\\"0\\\",\\\"is_phone\\\":1,\\\"tel\\\":\\\"13984719716\\\",\\\"source\\\":\\\"2021年报\\\",\\\"public_time\\\":\\\"2021-01-01 00:00:00\\\"}]\",\"to_time\":\"\",\"update_time\":\"2023-12-25 05:48:40\",\"wechat_public_num\":\"\"}";
        System.out.println(res.evaluate(text, "company_holder"));
        System.out.println(res.evaluate(text1, "company"));
    }
}
