package com.winhc.bigdata.udf;

import com.aliyun.odps.udf.UDF;
import com.aliyun.odps.utils.StringUtils;
import org.apache.commons.lang3.StringEscapeUtils;

import java.util.regex.Pattern;

/**
 * @Author: π
 * @Description: 去除标签
 */
public class TrimLableV2 extends UDF {
    public static final Pattern compile = Pattern.compile("<[^<>]+>");

    public String evaluate(String text) {
        if (StringUtils.isBlank(text)) return text;
//        return StringEscapeUtils.unescapeHtml4(compile.matcher(text).replaceAll(""));
        return compile.matcher(text).replaceAll("");
    }

    public static void main(String[] args) {
        TrimLableV2 res = new TrimLableV2();
        System.out.println(res.evaluate("<pstyle=\"LINE-HEIGHT:29px;TEXT-INDENT:37px\"><spanstyle=\"FONT-FAMILY:宋体;COLOR:black;FONT-SIZE:19px\">当事人在其施工的湖州市吴兴区织里镇碧桂园.嘉誉项目工地于2018年5月28日8时30分起开始向湖州市吴兴区织里镇碧桂园.嘉誉工地西侧通益路车行道排放污水，造成道路污染。至2018年5月28日10时00分被本局巡查发现时，排放污水污染道路面积为50平方米。</span></p><pstyle=\"LINE-HEIGHT:29px;TEXT-INDENT:37px\"><spanstyle=\"FONT-FAMILY:宋体;COLOR:black;FONT-SIZE:19px\">当事人的上述行为违反了《浙江省城市道路管理办法》第二十七条第四项的规定，属于向城市道路排放污水的行为。</span></p><pstyle=\"LINE-HEIGHT:29px;TEXT-INDENT:37px\"><spanstyle=\"FONT-FAMILY:宋体;COLOR:black;FONT-SIZE:19px\">鉴于当事人排放污水污染道路面积为50平方米，依据《浙江省城市道路管理办法》第三十六条的规定，决定对当事人作出如下行政处罚：罚款人民币20000元。</span></p><p></p>"));
        System.out.println(res.evaluate("<p>\n" +
                "\t当事人：由少帅，性别：男，民族：汉族，身份证号码：3702821986********</p>\n" +
                "<p>\n" +
                "\t2016年3月21日，我局执法人员根据举报经现场检查发现，当事人由少帅涉嫌制售侵犯他人注册商标专用权的服装。经本局负责人批准，于2016年3月21日对上述涉案服装予以扣押，并于当日立案调查。</p>\n" +
                "<p>\n" +
                "\t经查，当事人于2013年12月25日取得个体工商户营业执照，名称：即墨市****厂；经营者姓名:由少帅；组成形式：个人经营；经营场所：即墨市环秀办事处***；经营范围：制售服装及辅料。(以上范围需经许可经营的，须凭许可证经营）；注册号：3702826********。当事人于2015年12月底搬至即墨市通济街道办事处******，于2016年3月初开始制售&ldquo;H<sub>LL</sub>M&rdquo;打底裤，该&ldquo;H<sub>LL</sub>M&rdquo;标志与&ldquo;H<sub>&amp;</sub>M&rdquo;标志近似。已查明，&ldquo;H<sub>&amp;</sub>M&rdquo;注册商标的注册人及权利人为爱内斯&amp;毛里茨股份有限公司，商标注册号为5541599，核定使用的商品第25类：&ldquo;服装、鞋、帽（截止）&rdquo;，注册有效期：2010年04月07日至2020年04月06日。当事人制售的&ldquo;H<sub>LL</sub>M&rdquo;打底裤包装上的文字、图形的排列及颜色应用与爱内斯&amp;毛里茨股份有限公司制售的&ldquo;H<sub>&amp;</sub>M&rdquo;牌打底裤近似。本局根据相关证据，依法认定当事人制售的&ldquo;H<sub>LL</sub>M&rdquo;打底裤属于商标侵权的商品。当事人的行为，侵犯了&ldquo;H<sub>&amp;</sub>M&rdquo;注册商标专用权。截止案发，当事人共加工&ldquo;H<sub>LL</sub>M&rdquo;打底裤100条，已销售60条，售价45元/条，剩余40条待售。当事人的违法经营额共计4500元。当事人在被查处前，正办理营业执照经营场所的变更登记。</p>\n" +
                "<p>\n" +
                "\t上述事实有以下主要证据证明：</p>\n" +
                "<p>\n" +
                "\t第一组：当事人的身份证复印件。证明当事人的身份。</p>\n" +
                "<p>\n" +
                "\t第二组：当事人的营业执照复印件。证明当事人的登记情况。</p>\n" +
                "<p>\n" +
                "\t第三组：当事人的授权委托书及受委托人的身份证复印件各一份。证明了受委托人的委托权限及身份。</p>\n" +
                "<p>\n" +
                "\t第四组：现场笔录、询问笔录、当事人的经营现场及涉案商品照片、当事人使用的商标标识、送货单据等证据。证明当事人制售的&ldquo;H<sub>LL</sub>M&rdquo;打底裤系侵权商品以及经营情况等事实。</p>\n" +
                "<p>\n" +
                "\t第五组：&ldquo;H<sub>&amp;</sub>M&rdquo;商标注册证、商标使用授权书、营业执照等复印件。证明&ldquo;H<sub>&amp;</sub>M&rdquo;注册商标的所有人、核准使用的商品和核准使用的期限等事实。</p>\n" +
                "<p>\n" +
                "\t以上证据均由证据提供人、被询问(调查) 人签名或者盖章予以确认。</p>\n" +
                "<p>\n" +
                "\t本局于2016年4月19日向当事人送达了即市监听告字[2016]132号《行政处罚听证告知书》，依法告知了当事人拟作出行政处罚的事实、理由、依据、内容和陈述申辩及申请听证的权利。当事人在法定期限内未提出陈述申辩意见，也未申请举行听证。</p>\n" +
                "<p style=\"margin-left: 2.2pt\">\n" +
                "\t调查人员认为，&ldquo;H<sub>&amp;</sub>M&rdquo;注册商标经商标局核准注册依法享有商标专用权，除爱内斯&amp;毛里茨股份有限公司及其授权人外，任何人不得擅自使用。本案查获的&ldquo;H<sub>LL</sub>M&rdquo;打底裤，在其标签上擅自使用了与&ldquo;H<sub>&amp;</sub>M&rdquo;注册商标近似的标识，侵犯了&ldquo;H<sub>&amp;</sub>M&rdquo;注册商标专用权，属于在同一种商品上对他人注册商标作近似使用的侵权商品。当事人制售该侵权商品，其行为属于《中华人民共和国商标法》第五十七条&ldquo;有下列行为之一的，均属侵犯注册商标专用权：（二）未经商标注册人的许可，在同一种商品上使用与其注册商标近似的商标，或者在类似商品上使用与其注册商标相同或者近似的商标，容易导致混淆的；&rdquo;以及《中华人民共和国商标法实施条例》第七十六条：&ldquo;在同一种商品或者类似商品上将与他人注册商标相同或者近似的标志作为商品名称或者商品装"));
    }
}
