package com.winhc.bigdata.udf;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONPath;
import com.aliyun.odps.udf.UDF;
import com.aliyun.odps.utils.StringUtils;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * @Author: π
 * @Description: 获取json 里字段
 */
public class get_json_object_v2 extends UDF {

    public String evaluate(String jsons, String json_path) {
        if (StringUtils.isBlank(jsons)) {
            return null;
        }
        try {
            String re = parse(jsons, json_path);
            return re;
        } catch (Exception e) {
            return null;
        }
    }

    public String parse(String json, String json_path) {
        Object re = JSONPath.eval(JSON.parse(json), json_path);
        if(re == null){
            return null;
        }
        return re.toString();
    }

    public static void main(String[] args) {
        String jsons = "{\"plaintiff_info\":\"[{\\\"judge_tendency\\\":\\\"\\\",\\\"litigant_id\\\":\\\"\\\",\\\"name\\\":\\\"上海市杨浦区人力资源和社会保障局\\\"}]\",\"date\":\"2022-12-19 00:00:00\",\"party_title\":\"[{\\\"judge_tendency\\\":\\\"\\\",\\\"litigant_id\\\":\\\"\\\",\\\"name\\\":\\\"上海市杨浦区人力资源和社会保障局\\\",\\\"party_title\\\":\\\"申请执行人\\\"},{\\\"judge_tendency\\\":\\\"终结本次执行\\\",\\\"litigant_id\\\":\\\"\\\",\\\"name\\\":\\\"上海绿动传播有限公司\\\",\\\"party_title\\\":\\\"被执行人\\\"}]\",\"defendant_info\":\"[{\\\"judge_tendency\\\":\\\"终结本次执行\\\",\\\"litigant_id\\\":\\\"\\\",\\\"name\\\":\\\"上海绿动传播有限公司\\\"}]\",\"is_success\":\"其他\",\"case_reason_level4\":\"行政强制\",\"judge_date\":\"2022-12-19 00:00:00\",\"judge_year\":\"2022\"}";
        jsons ="{\"date\":\"2019-05-29 00:00:00\",\"plaintiff_info\":\"[{\\\"judge_tendency\\\":\\\"\\\",\\\"litigant_id\\\":\\\"e30f5db70b0b4d5f968c678f8fab5360\\\",\\\"name\\\":\\\"雅安市名山区人民检察院\\\"}]\",\"party_title\":\"[{\\\"judge_tendency\\\":\\\"\\\",\\\"litigant_id\\\":\\\"e30f5db70b0b4d5f968c678f8fab5360\\\",\\\"name\\\":\\\"雅安市名山区人民检察院\\\",\\\"party_title\\\":\\\"公诉机关\\\"},{\\\"judge_tendency\\\":\\\"\\\",\\\"litigant_id\\\":\\\"\\\",\\\"name\\\":\\\"黄兴\\\",\\\"party_title\\\":\\\"被告人\\\"}]\",\"defendant_info\":\"[{\\\"judge_tendency\\\":\\\"\\\",\\\"litigant_id\\\":\\\"\\\",\\\"name\\\":\\\"黄兴\\\"}]\",\"judge_date\":\"2019-05-29 00:00:00\",\"is_success\":\"胜\",\"case_reason_level4\":\"容留他人吸毒罪\",\"judge_year\":\"2019\"}";
        String json_path = "$.judge_year";

        get_json_object_v2 n = new get_json_object_v2();
        System.out.println(n.evaluate(jsons, json_path));
    }

}


