package com.winhc.bigdata.udf;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.odps.udf.UDF;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;

import java.util.Collection;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

/**
 * @Author: π
 * @Description: 结果比较
 */
public class name_compare extends UDF {


    public String evaluate(String yg_name1, String yg_name2, String bg_name1, String bg_name2) {
        return compare(extracted(yg_name1), extracted(yg_name2)) + compare(extracted(bg_name1), extracted(bg_name2));
    }

    private static String compare(List<String> name1, List<String> name2) {
        if (CollectionUtils.isEmpty(name1) && CollectionUtils.isEmpty(name2)) {
            return "0";
        }

        Collection intersection = CollectionUtils.intersection(name1, name2);

        if (intersection.size() == name1.size() && intersection.size() == name2.size()) {
            return "0";
        }
        return "1";
    }

    private static List<String> extracted(String name) {
        List<String> list = JSON.parseArray(name).toJavaList(JSONObject.class)
                .stream()
                .map(x -> x.getString("name"))
                .filter(StringUtils::isNotBlank)
                .distinct().collect(Collectors.toList());
        return list;
    }

    public static void main(String[] args) {
        String res = new name_compare().evaluate("", "", "", "");
        System.out.println(res);

    }
}
