package com.winhc.bigdata.udf;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.odps.udf.UDF;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @Author: π
 * @Description: 名称包含
 */
public class name_contains extends UDF {


    public String evaluate(String yg_name1, String bg_name1) {
        return compare(extracted(yg_name1), extracted(bg_name1));
    }

    private static String compare(List<String> name1, List<String> name2) {
        if (CollectionUtils.isEmpty(name1) || CollectionUtils.isEmpty(name2)) {
            return "0";
        }

        Collection intersection = CollectionUtils.intersection(name1, name2);

        if (intersection.size() > 0) {
            return "1";
        }
        return "0";
    }

    private static List<String> extracted(String name) {
        if(StringUtils.isBlank(name)){
            return new ArrayList<>();
        }
        List<String> list = JSON.parseArray(name).toJavaList(JSONObject.class)
                .stream()
                .map(x -> x.getString("name"))
                .filter(StringUtils::isNotBlank)
                .distinct().collect(Collectors.toList());
        return list;
    }

    public static void main(String[] args) {


    }
}
